diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/fd-net-device/model/fd-net-device.cc ns-3.35/src/fd-net-device/model/fd-net-device.cc
--- ns-3.34/src/fd-net-device/model/fd-net-device.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/fd-net-device/model/fd-net-device.cc	2021-10-01 13:26:47.000000000 -0700
@@ -296,6 +296,13 @@
       m_fd = -1;
     }
 
+  while (!m_pendingQueue.empty ())
+    {
+      std::pair<uint8_t *, ssize_t> next = m_pendingQueue.front ();
+      m_pendingQueue.pop ();
+      FreeBuffer (next.first);
+    }
+
   DoFinishStoppingDevice ();
 }
 
@@ -415,6 +422,12 @@
   uint8_t *buf = 0;
   ssize_t len = 0;
 
+  if (m_pendingQueue.empty())
+  {
+    NS_LOG_LOGIC ("buffer is empty, probably the device is stopped.");
+    return;
+  }
+
   {
     CriticalSection cs (m_pendingReadMutex);
     std::pair<uint8_t *, ssize_t> next = m_pendingQueue.front ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/bindings/modulegen__gcc_ILP32.py ns-3.35/src/flow-monitor/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/flow-monitor/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
@@ -1694,11 +1694,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1771,6 +1766,11 @@
     cls.add_constructor([param('ns3::Ipv4Address', 'local'), param('ns3::Ipv4Mask', 'mask')])
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4InterfaceAddress const & o) [constructor]
     cls.add_constructor([param('ns3::Ipv4InterfaceAddress const &', 'o')])
+    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetAddress() const [member function]
+    cls.add_method('GetAddress', 
+                   'ns3::Ipv4Address', 
+                   [], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetBroadcast() const [member function]
     cls.add_method('GetBroadcast', 
                    'ns3::Ipv4Address', 
@@ -1791,11 +1791,20 @@
                    'ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsInSameSubnet(ns3::Ipv4Address const b) const [member function]
+    cls.add_method('IsInSameSubnet', 
+                   'bool', 
+                   [param('ns3::Ipv4Address const', 'b')], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsSecondary() const [member function]
     cls.add_method('IsSecondary', 
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetAddress(ns3::Ipv4Address address) [member function]
+    cls.add_method('SetAddress', 
+                   'void', 
+                   [param('ns3::Ipv4Address', 'address')])
     ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetBroadcast(ns3::Ipv4Address broadcast) [member function]
     cls.add_method('SetBroadcast', 
                    'void', 
@@ -1864,11 +1873,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1985,11 +1989,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2253,11 +2252,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -3786,11 +3780,16 @@
                    'std::string', 
                    [param('ns3::Ipv6Header::EcnType', 'ecn')], 
                    is_const=True)
+    ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetDestination() const [member function]
+    cls.add_method('GetDestination', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetDestinationAddress() const [member function]
     cls.add_method('GetDestinationAddress', 
                    'ns3::Ipv6Address', 
                    [], 
-                   is_const=True)
+                   deprecated=True, is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Header::DscpType ns3::Ipv6Header::GetDscp() const [member function]
     cls.add_method('GetDscp', 
                    'ns3::Ipv6Header::DscpType', 
@@ -3831,11 +3830,16 @@
                    'uint32_t', 
                    [], 
                    is_const=True, is_virtual=True)
+    ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetSource() const [member function]
+    cls.add_method('GetSource', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetSourceAddress() const [member function]
     cls.add_method('GetSourceAddress', 
                    'ns3::Ipv6Address', 
                    [], 
-                   is_const=True)
+                   deprecated=True, is_const=True)
     ## ipv6-header.h (module 'internet'): uint8_t ns3::Ipv6Header::GetTrafficClass() const [member function]
     cls.add_method('GetTrafficClass', 
                    'uint8_t', 
@@ -3856,10 +3860,15 @@
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
                    is_const=True, is_virtual=True)
+    ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDestination(ns3::Ipv6Address dst) [member function]
+    cls.add_method('SetDestination', 
+                   'void', 
+                   [param('ns3::Ipv6Address', 'dst')])
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDestinationAddress(ns3::Ipv6Address dst) [member function]
     cls.add_method('SetDestinationAddress', 
                    'void', 
-                   [param('ns3::Ipv6Address', 'dst')])
+                   [param('ns3::Ipv6Address', 'dst')], 
+                   deprecated=True)
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDscp(ns3::Ipv6Header::DscpType dscp) [member function]
     cls.add_method('SetDscp', 
                    'void', 
@@ -3884,10 +3893,15 @@
     cls.add_method('SetPayloadLength', 
                    'void', 
                    [param('uint16_t', 'len')])
+    ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetSource(ns3::Ipv6Address src) [member function]
+    cls.add_method('SetSource', 
+                   'void', 
+                   [param('ns3::Ipv6Address', 'src')])
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetSourceAddress(ns3::Ipv6Address src) [member function]
     cls.add_method('SetSourceAddress', 
                    'void', 
-                   [param('ns3::Ipv6Address', 'src')])
+                   [param('ns3::Ipv6Address', 'src')], 
+                   deprecated=True)
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetTrafficClass(uint8_t traffic) [member function]
     cls.add_method('SetTrafficClass', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/bindings/modulegen__gcc_LP64.py ns-3.35/src/flow-monitor/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/flow-monitor/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -1694,11 +1694,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1771,6 +1766,11 @@
     cls.add_constructor([param('ns3::Ipv4Address', 'local'), param('ns3::Ipv4Mask', 'mask')])
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4InterfaceAddress const & o) [constructor]
     cls.add_constructor([param('ns3::Ipv4InterfaceAddress const &', 'o')])
+    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetAddress() const [member function]
+    cls.add_method('GetAddress', 
+                   'ns3::Ipv4Address', 
+                   [], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetBroadcast() const [member function]
     cls.add_method('GetBroadcast', 
                    'ns3::Ipv4Address', 
@@ -1791,11 +1791,20 @@
                    'ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsInSameSubnet(ns3::Ipv4Address const b) const [member function]
+    cls.add_method('IsInSameSubnet', 
+                   'bool', 
+                   [param('ns3::Ipv4Address const', 'b')], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsSecondary() const [member function]
     cls.add_method('IsSecondary', 
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetAddress(ns3::Ipv4Address address) [member function]
+    cls.add_method('SetAddress', 
+                   'void', 
+                   [param('ns3::Ipv4Address', 'address')])
     ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetBroadcast(ns3::Ipv4Address broadcast) [member function]
     cls.add_method('SetBroadcast', 
                    'void', 
@@ -1864,11 +1873,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1985,11 +1989,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2253,11 +2252,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -3786,11 +3780,16 @@
                    'std::string', 
                    [param('ns3::Ipv6Header::EcnType', 'ecn')], 
                    is_const=True)
+    ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetDestination() const [member function]
+    cls.add_method('GetDestination', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetDestinationAddress() const [member function]
     cls.add_method('GetDestinationAddress', 
                    'ns3::Ipv6Address', 
                    [], 
-                   is_const=True)
+                   deprecated=True, is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Header::DscpType ns3::Ipv6Header::GetDscp() const [member function]
     cls.add_method('GetDscp', 
                    'ns3::Ipv6Header::DscpType', 
@@ -3831,11 +3830,16 @@
                    'uint32_t', 
                    [], 
                    is_const=True, is_virtual=True)
+    ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetSource() const [member function]
+    cls.add_method('GetSource', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-header.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6Header::GetSourceAddress() const [member function]
     cls.add_method('GetSourceAddress', 
                    'ns3::Ipv6Address', 
                    [], 
-                   is_const=True)
+                   deprecated=True, is_const=True)
     ## ipv6-header.h (module 'internet'): uint8_t ns3::Ipv6Header::GetTrafficClass() const [member function]
     cls.add_method('GetTrafficClass', 
                    'uint8_t', 
@@ -3856,10 +3860,15 @@
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
                    is_const=True, is_virtual=True)
+    ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDestination(ns3::Ipv6Address dst) [member function]
+    cls.add_method('SetDestination', 
+                   'void', 
+                   [param('ns3::Ipv6Address', 'dst')])
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDestinationAddress(ns3::Ipv6Address dst) [member function]
     cls.add_method('SetDestinationAddress', 
                    'void', 
-                   [param('ns3::Ipv6Address', 'dst')])
+                   [param('ns3::Ipv6Address', 'dst')], 
+                   deprecated=True)
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetDscp(ns3::Ipv6Header::DscpType dscp) [member function]
     cls.add_method('SetDscp', 
                    'void', 
@@ -3884,10 +3893,15 @@
     cls.add_method('SetPayloadLength', 
                    'void', 
                    [param('uint16_t', 'len')])
+    ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetSource(ns3::Ipv6Address src) [member function]
+    cls.add_method('SetSource', 
+                   'void', 
+                   [param('ns3::Ipv6Address', 'src')])
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetSourceAddress(ns3::Ipv6Address src) [member function]
     cls.add_method('SetSourceAddress', 
                    'void', 
-                   [param('ns3::Ipv6Address', 'src')])
+                   [param('ns3::Ipv6Address', 'src')], 
+                   deprecated=True)
     ## ipv6-header.h (module 'internet'): void ns3::Ipv6Header::SetTrafficClass(uint8_t traffic) [member function]
     cls.add_method('SetTrafficClass', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/examples/flowmon-parse-results.py ns-3.35/src/flow-monitor/examples/flowmon-parse-results.py
--- ns-3.34/src/flow-monitor/examples/flowmon-parse-results.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/examples/flowmon-parse-results.py	2021-10-01 13:26:47.000000000 -0700
@@ -8,7 +8,7 @@
 
 def parse_time_ns(tm):
     if tm.endswith('ns'):
-        return long(tm[:-4])
+        return float(tm[:-2])
     raise ValueError(tm)
 
 
@@ -26,11 +26,11 @@
     #  source port
     ## @var destinationPort 
     #  destination port
-    ## @var __slots__ 
+    ## @var __slots_ 
     #  class variable list
-    __slots__ = ['sourceAddress', 'destinationAddress', 'protocol', 'sourcePort', 'destinationPort']
+    __slots_ = ['sourceAddress', 'destinationAddress', 'protocol', 'sourcePort', 'destinationPort']
     def __init__(self, el):
-        '''The initializer.
+        '''! The initializer.
         @param self The object pointer.
         @param el The element.
         '''
@@ -49,11 +49,11 @@
     #  number of bins
     ## @var number_of_flows
     #  number of flows
-    ## @var __slots__
+    ## @var __slots_
     #  class variable list
-    __slots__ = 'bins', 'nbins', 'number_of_flows'
+    __slots_ = 'bins', 'nbins', 'number_of_flows'
     def __init__(self, el=None):
-        ''' The initializer.
+        '''! The initializer.
         @param self The object pointer.
         @param el The element.
         '''
@@ -88,21 +88,22 @@
     #  flow histogram
     ## @var rx_duration
     #  receive duration
-    ## @var __slots__
+    ## @var __slots_
     #  class variable list
-    __slots__ = ['flowId', 'delayMean', 'packetLossRatio', 'rxBitrate', 'txBitrate',
-                 'fiveTuple', 'packetSizeMean', 'probe_stats_unsorted',
-                 'hopCount', 'flowInterruptionsHistogram', 'rx_duration']
+    __slots_ = ['flowId', 'delayMean', 'packetLossRatio', 'rxBitrate', 'txBitrate',
+                'fiveTuple', 'packetSizeMean', 'probe_stats_unsorted',
+                'hopCount', 'flowInterruptionsHistogram', 'rx_duration']
     def __init__(self, flow_el):
-        ''' The initializer.
+        '''! The initializer.
         @param self The object pointer.
         @param flow_el The element.
         '''
         self.flowId = int(flow_el.get('flowId'))
-        rxPackets = long(flow_el.get('rxPackets'))
-        txPackets = long(flow_el.get('txPackets'))
-        tx_duration = float(long(flow_el.get('timeLastTxPacket')[:-4]) - long(flow_el.get('timeFirstTxPacket')[:-4]))*1e-9
-        rx_duration = float(long(flow_el.get('timeLastRxPacket')[:-4]) - long(flow_el.get('timeFirstRxPacket')[:-4]))*1e-9
+        rxPackets = float(flow_el.get('rxPackets'))
+        txPackets = float(flow_el.get('txPackets'))
+
+        tx_duration = (parse_time_ns (flow_el.get('timeLastTxPacket')) - parse_time_ns(flow_el.get('timeFirstTxPacket')))*1e-9
+        rx_duration = (parse_time_ns (flow_el.get('timeLastRxPacket')) - parse_time_ns(flow_el.get('timeFirstRxPacket')))*1e-9
         self.rx_duration = rx_duration
         self.probe_stats_unsorted = []
         if rxPackets:
@@ -110,17 +111,17 @@
         else:
             self.hopCount = -1000
         if rxPackets:
-            self.delayMean = float(flow_el.get('delaySum')[:-4]) / rxPackets * 1e-9
+            self.delayMean = float(flow_el.get('delaySum')[:-2]) / rxPackets * 1e-9
             self.packetSizeMean = float(flow_el.get('rxBytes')) / rxPackets
         else:
             self.delayMean = None
             self.packetSizeMean = None
         if rx_duration > 0:
-            self.rxBitrate = long(flow_el.get('rxBytes'))*8 / rx_duration
+            self.rxBitrate = float(flow_el.get('rxBytes'))*8 / rx_duration
         else:
             self.rxBitrate = None
         if tx_duration > 0:
-            self.txBitrate = long(flow_el.get('txBytes'))*8 / tx_duration
+            self.txBitrate = float(flow_el.get('txBytes'))*8 / tx_duration
         else:
             self.txBitrate = None
         lost = float(flow_el.get('lostPackets'))
@@ -147,9 +148,9 @@
     #  bytes
     ## @var delayFromFirstProbe
     #  delay from first probe
-    ## @var __slots__
+    ## @var __slots_
     #  class variable list
-    __slots__ = ['probeId', 'packets', 'bytes', 'delayFromFirstProbe']
+    __slots_ = ['probeId', 'packets', 'bytes', 'delayFromFirstProbe']
 
 ## Simulation
 class Simulation(object):
@@ -157,7 +158,7 @@
     ## @var flows
     #  list of flows
     def __init__(self, simulation_el):
-        ''' The initializer.
+        '''! The initializer.
         @param self The object pointer.
         @param simulation_el The element.
         '''
@@ -178,7 +179,7 @@
                 flowId = int(stats.get('flowId'))
                 s = ProbeFlowStats()
                 s.packets = int(stats.get('packets'))
-                s.bytes = long(stats.get('bytes'))
+                s.bytes = float(stats.get('bytes'))
                 s.probeId = probeId
                 if s.packets > 0:
                     s.delayFromFirstProbe =  parse_time_ns(stats.get('delayFromFirstProbeSum')) / float(s.packets)
@@ -189,7 +190,7 @@
 
 def main(argv):
     file_obj = open(argv[1])
-    print "Reading XML file ",
+    print("Reading XML file ", end=" ")
  
     sys.stdout.flush()        
     level = 0
@@ -205,31 +206,31 @@
                 elem.clear() # won't need this any more
                 sys.stdout.write(".")
                 sys.stdout.flush()
-    print " done."
+    print(" done.")
 
 
     for sim in sim_list:
         for flow in sim.flows:
             t = flow.fiveTuple
             proto = {6: 'TCP', 17: 'UDP'} [t.protocol]
-            print "FlowID: %i (%s %s/%s --> %s/%i)" % \
-                (flow.flowId, proto, t.sourceAddress, t.sourcePort, t.destinationAddress, t.destinationPort)
+            print("FlowID: %i (%s %s/%s --> %s/%i)" % \
+                (flow.flowId, proto, t.sourceAddress, t.sourcePort, t.destinationAddress, t.destinationPort))
             if flow.txBitrate is None:
-                print "\tTX bitrate: None"
+                print("\tTX bitrate: None")
             else:
-                print "\tTX bitrate: %.2f kbit/s" % (flow.txBitrate*1e-3,)
+                print("\tTX bitrate: %.2f kbit/s" % (flow.txBitrate*1e-3,))
             if flow.rxBitrate is None:
-                print "\tRX bitrate: None"
+                print("\tRX bitrate: None")
             else:
-                print "\tRX bitrate: %.2f kbit/s" % (flow.rxBitrate*1e-3,)
+                print("\tRX bitrate: %.2f kbit/s" % (flow.rxBitrate*1e-3,))
             if flow.delayMean is None:
-                print "\tMean Delay: None"
+                print("\tMean Delay: None")
             else:
-                print "\tMean Delay: %.2f ms" % (flow.delayMean*1e3,)
+                print("\tMean Delay: %.2f ms" % (flow.delayMean*1e3,))
             if flow.packetLossRatio is None:
-                print "\tPacket Loss Ratio: None"
+                print("\tPacket Loss Ratio: None")
             else:
-                print "\tPacket Loss Ratio: %.2f %%" % (flow.packetLossRatio*100)
+                print("\tPacket Loss Ratio: %.2f %%" % (flow.packetLossRatio*100))
 
 
 if __name__ == '__main__':
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/model/flow-monitor.cc ns-3.35/src/flow-monitor/model/flow-monitor.cc
--- ns-3.34/src/flow-monitor/model/flow-monitor.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/model/flow-monitor.cc	2021-10-01 13:26:47.000000000 -0700
@@ -430,14 +430,15 @@
     {
       os << std::string ( indent, ' ' );
 #define ATTRIB(name) << " " # name "=\"" << flowI->second.name << "\""
+#define ATTRIB_TIME(name) << " " #name "=\"" << flowI->second.name.As (Time::NS) << "\""
       os << "<Flow flowId=\"" << flowI->first << "\""
-      ATTRIB (timeFirstTxPacket)
-      ATTRIB (timeFirstRxPacket)
-      ATTRIB (timeLastTxPacket)
-      ATTRIB (timeLastRxPacket)
-      ATTRIB (delaySum)
-      ATTRIB (jitterSum)
-      ATTRIB (lastDelay)
+      ATTRIB_TIME (timeFirstTxPacket)
+      ATTRIB_TIME (timeFirstRxPacket)
+      ATTRIB_TIME (timeLastTxPacket)
+      ATTRIB_TIME (timeLastRxPacket)
+      ATTRIB_TIME (delaySum)
+      ATTRIB_TIME (jitterSum)
+      ATTRIB_TIME (lastDelay)
       ATTRIB (txBytes)
       ATTRIB (rxBytes)
       ATTRIB (txPackets)
@@ -445,6 +446,7 @@
       ATTRIB (lostPackets)
       ATTRIB (timesForwarded)
       << ">\n";
+#undef ATTRIB_TIME
 #undef ATTRIB
 
       indent += 2;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/model/ipv6-flow-classifier.cc ns-3.35/src/flow-monitor/model/ipv6-flow-classifier.cc
--- ns-3.34/src/flow-monitor/model/ipv6-flow-classifier.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/model/ipv6-flow-classifier.cc	2021-10-01 13:26:47.000000000 -0700
@@ -105,15 +105,15 @@
 Ipv6FlowClassifier::Classify (const Ipv6Header &ipHeader, Ptr<const Packet> ipPayload,
                               uint32_t *out_flowId, uint32_t *out_packetId)
 {
-  if (ipHeader.GetDestinationAddress ().IsMulticast ())
+  if (ipHeader.GetDestination ().IsMulticast ())
     {
       // we are not prepared to handle multicast yet
       return false;
     }
 
   FiveTuple tuple;
-  tuple.sourceAddress = ipHeader.GetSourceAddress ();
-  tuple.destinationAddress = ipHeader.GetDestinationAddress ();
+  tuple.sourceAddress = ipHeader.GetSource ();
+  tuple.destinationAddress = ipHeader.GetDestination ();
   tuple.protocol = ipHeader.GetNextHeader ();
 
   if ((tuple.protocol != UDP_PROT_NUMBER) && (tuple.protocol != TCP_PROT_NUMBER))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/flow-monitor/model/ipv6-flow-probe.cc ns-3.35/src/flow-monitor/model/ipv6-flow-probe.cc
--- ns-3.34/src/flow-monitor/model/ipv6-flow-probe.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/flow-monitor/model/ipv6-flow-probe.cc	2021-10-01 13:26:47.000000000 -0700
@@ -341,7 +341,7 @@
 
       uint32_t size = (ipPayload->GetSize () + ipHeader.GetSerializedSize ());
       NS_LOG_DEBUG ("Drop ("<<this<<", "<<flowId<<", "<<packetId<<", "<<size<<", " << reason 
-                            << ", destIp=" << ipHeader.GetDestinationAddress () << "); "
+                            << ", destIp=" << ipHeader.GetDestination () << "); "
                             << "HDR: " << ipHeader << " PKT: " << *ipPayload);
 
       DropReason myReason;
